"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
var react_native_redash_1 = require("react-native-redash");
var Segment_1 = __importDefault(require("./Segment"));
exports.SegmentedControl = function (_a) {
    var inactiveTintColor = _a.inactiveTintColor, activeTintColor = _a.activeTintColor, _b = _a.onChangeValue, onChangeValue = _b === void 0 ? function () { } : _b, defaultSelectedIndex = _a.defaultSelectedIndex, style = _a.style, values = _a.values;
    var _c = react_1.useState(0), _width = _c[0], _setWidth = _c[1];
    var _d = react_1.useState(defaultSelectedIndex), _activeIndex = _d[0], _setActiveIndex = _d[1];
    var _e = react_1.useState(new react_native_reanimated_1.default.Value(0)), _sliderPosition = _e[0], _setSliderPosition = _e[1];
    var _f = react_1.useState(0), _sliderWidth = _f[0], _setSliderWidth = _f[1];
    var handleChangeValue = function (index) {
        if (typeof _activeIndex === "undefined") {
            _setSliderPosition(new react_native_reanimated_1.default.Value(_width * (index / values.length)));
        }
        _setActiveIndex(index);
        onChangeValue(index);
    };
    react_1.useEffect(function () {
        _setSliderWidth(_width * (1 / values.length - 0.015));
    }, [values, _width]);
    react_1.useEffect(function () {
        if (typeof defaultSelectedIndex !== "undefined") {
            _setSliderPosition(new react_native_reanimated_1.default.Value(_width * (defaultSelectedIndex / values.length)));
        }
    }, [values, _width, defaultSelectedIndex]);
    // This hook is used to animate the slider position
    react_native_reanimated_1.default.useCode(function () {
        var index = _activeIndex || 0;
        var sliderPosition = _width * (index / values.length);
        return react_native_reanimated_1.default.set(_sliderPosition, react_native_redash_1.timing({
            from: _sliderPosition,
            to: sliderPosition,
            easing: react_native_reanimated_1.Easing.linear,
            duration: 200
        }));
    }, [_activeIndex]);
    return (react_1.default.createElement(react_native_1.View, { onLayout: function (event) { return _setWidth(event.nativeEvent.layout.width); }, style: [styles.container, style] },
        typeof _activeIndex !== "undefined" && (react_1.default.createElement(react_native_reanimated_1.default.View
        // @ts-ignore
        , { 
            // @ts-ignore
            style: [
                styles.slider,
                {
                    width: _sliderWidth,
                    transform: [
                        {
                            translateX: _sliderPosition
                        }
                    ]
                }
            ] })),
        values.map(function (value, index) {
            return (react_1.default.createElement(react_1.default.Fragment, { key: value },
                index > 0 && (react_1.default.createElement(react_native_1.View, { style: styles.dividerContainer },
                    react_1.default.createElement(react_native_1.View, { style: styles.divider }))),
                react_1.default.createElement(Segment_1.default, { active: _activeIndex === index, onChangeValue: function () { return handleChangeValue(index); }, content: value, inactiveTintColor: inactiveTintColor, activeTintColor: activeTintColor })));
        })));
};
var styles = react_native_1.StyleSheet.create({
    container: {
        backgroundColor: "#eeeeef",
        flexDirection: "row",
        alignItems: "center",
        borderRadius: 8,
        height: 28,
        position: "relative"
    },
    slider: {
        position: "absolute",
        top: 0,
        left: 0,
        height: "86%",
        backgroundColor: "white",
        borderRadius: 7,
        margin: 2,
        shadowOffset: { width: 0.95, height: 0.95 },
        shadowColor: "#a2a2a2",
        shadowOpacity: 0.5,
        shadowRadius: 2,
        zIndex: 1
    },
    dividerContainer: {
        paddingTop: 7,
        paddingBottom: 7,
        zIndex: 0
    },
    divider: {
        height: "100%",
        width: 1,
        borderWidth: 0,
        backgroundColor: "rgba(120, 120, 120, 0.2)"
    }
});
exports.default = exports.SegmentedControl;
//# sourceMappingURL=SegmentedControl.js.map